﻿''' <summary>
''' This class receives Bitmap image and creates binay tiles from it.
''' Binary representation can be used as input for a neural net.
''' </summary>
Public Class Simplifier
    ''' <summary>
    ''' Creates simple binary representation.
    ''' </summary>
    Public Shared Function getBinaryTiles(ByVal bmp As Bitmap, ByVal iRowCount As Integer, ByVal iColumnCount As Integer, ByVal iPercentNeeded As Integer) As Boolean(,)
        Dim iTileWidth As Integer = CInt(bmp.Width / iColumnCount)
        Dim iTileHeight As Integer = CInt(bmp.Height / iRowCount)
        Dim iPixelsInTile As Integer = iTileHeight * iTileWidth
        Dim bBinary(iColumnCount - 1, iRowCount - 1) As Boolean
        Dim iTileX As Integer = 0
        Dim iTileY As Integer = 0
        For iX = 0 To bmp.Width - 1 Step iTileWidth
            For iY = 0 To bmp.Height - 1 Step iTileHeight
                Dim iCountMarkedPixelsInTile As Integer = 0
                For x = iX To iX + iTileWidth - 1
                    For y = iY To iY + iTileHeight - 1
                        If bmp.GetPixel(x, y).GetBrightness = 0 Then
                            iCountMarkedPixelsInTile += 1
                        End If
                    Next
                Next
                Dim iPercent As Integer = CInt(Math.Round(100 / iPixelsInTile * iCountMarkedPixelsInTile, 0))
                If iPercent >= iPercentNeeded Then
                    bBinary(iTileX, iTileY) = True
                Else
                    bBinary(iTileX, iTileY) = False
                End If
                iTileY += 1
            Next
            iTileX += 1
            iTileY = 0
        Next
        Return bBinary
    End Function
End Class
